## org.hibernate.dialect
Class CUBRIDDialect

    java.lang.Object
      org.hibernate.dialect.Dialect
          org.hibernate.dialect.CUBRIDDialect

All Implemented Interfaces:
  ConversionContext

    public class CUBRIDDialect

extends Dialect

An SQL dialect for CUBRID (8.3.x and later).

Field Summary

Fields inherited from class org.hibernate.dialect.Dialect
`CLOSED_QUOTE, DEFAULT_BATCH_SIZE, LEGACY_LOB_MERGE_STRATEGY, NEW_LOCATOR_LOB_MERGE_STRATEGY, NO_BATCH, QUOTE, STREAM_XFER_LOB_MERGE_STRATEGY`

Constructor Summary
`CUBRIDDialect()`

Method Summary
`boolean` `bindLimitParametersInReverseOrder()` ANSI SQL defines the LIMIT clause to be in the form LIMIT offset, limit.
`char` `closeQuote()` The character specific to this dialect used to close a quoted identifier.
`boolean` `dropConstraints()` Do we need to drop constraints before dropping tables in this dialect?
`boolean` `forUpdateOfColumns()` Is `FOR UPDATE OF` syntax supported?
`String` `getAddColumnString()` The syntax used to add a column to a table (optional).
`String` `getCreateSequenceString(String sequenceName)` Typically dialects which support sequences can create a sequence with a single command.
`String` `getCurrentTimestampSelectString()` Retrieve the command used to retrieve the current timestamp from the database.
`String` `getDropSequenceString(String sequenceName)` Typically dialects which support sequences can drop a sequence with a single command.
`String` `getForUpdateString()` Get the string to append to SELECT statements to acquire locks for this dialect.
`protected String` `getIdentityColumnString()` The syntax used during DDL to define a column as being an IDENTITY.
`String` `getIdentitySelectString(String table, String column, int type)` Get the select command to use to retrieve the last generated IDENTITY value for a particular table
`String` `getLimitString(String sql, boolean hasOffset)` Apply s limit clause to the query.
`String` `getQuerySequencesString()` Get the select command used retrieve the names of all sequences.
`String` `getSequenceNextValString(String sequenceName)` Generate the appropriate select statement to to retrieve the next value of a sequence.
`boolean` `hasAlterTable()` Does this dialect support the `ALTER TABLE` syntax?
`boolean` `isCurrentTimestampSelectStringCallable()` Should the value returned by `Dialect.getCurrentTimestampSelectString()` be treated as callable.
`char` `openQuote()` The character specific to this dialect used to begin a quoted identifier.
`boolean` `supportsCommentOn()`
`boolean` `supportsCurrentTimestampSelection()` Does this dialect support a way to retrieve the database's current timestamp value?
`boolean` `supportsLimit()` Does this dialect support some form of limiting query results via a SQL clause?
`boolean` `supportsSequences()` Does this dialect support sequences?
`boolean` `supportsTemporaryTables()` Does this dialect support temporary tables?
`boolean` `supportsUnionAll()` Does this dialect support UNION ALL, which is generally a faster variant of UNION?
`boolean` `useMaxForLimit()` Does the `LIMIT` clause take a "maximum" row number instead of a total number of returned rows? This is easiest understood via an example.

Methods inherited from class org.hibernate.dialect.Dialect

`appendIdentitySelectToInsert, appendLockHint, applyLocksToSql, areStringComparisonsCaseInsensitive, bindLimitParametersFirst, buildSQLExceptionConversionDelegate, buildSQLExceptionConverter, convertToFirstRowValue, createCaseFragment, createOuterJoinFragment, doesReadCommittedCauseWritersToBlockReaders, doesRepeatableReadCauseReadersToBlockWriters, dropTemporaryTableAfterUse, forceLimitUsage, generateTemporaryTableName, getAddForeignKeyConstraintString, getAddPrimaryKeyConstraintString, getAddUniqueConstraintString, getCascadeConstraintsString, getCaseInsensitiveLike, getCastTypeName, getColumnAliasExtractor, getColumnComment, getCreateMultisetTableString, getCreateSequenceString, getCreateSequenceStrings, getCreateSequenceStrings, getCreateTableString, getCreateTemporaryTablePostfix, getCreateTemporaryTableString, getCrossJoinSeparator, getCurrentTimestampSQLFunctionName, getDefaultProperties, getDialect, getDialect, getDropForeignKeyString, getDropSequenceStrings, getDropTemporaryTableString, getForUpdateNowaitString, getForUpdateNowaitString, getForUpdateString, getForUpdateString, getForUpdateString, getForUpdateString, getFunctions, getHibernateTypeName, getHibernateTypeName, getIdentityColumnString, getIdentityInsertString, getIdentitySelectString, getKeywords, getLimitString, getLobMergeStrategy, getLockingStrategy, getLowercaseFunction, getMaxAliasLength, getNativeIdentifierGeneratorClass, getNoColumnsInsertString, getNullColumnString, getReadLockString, getResultSet, getSelectClauseNullString, getSelectGUIDString, getSelectSequenceNextValString, getSqlTypeDescriptorOverride, getTableComment, getTableTypeString, getTypeName, getTypeName, getViolatedConstraintNameExtracter, getWriteLockString, hasDataTypeInIdentityColumn, hasSelfReferentialForeignKeyBug, isLockTimeoutParameterized, performTemporaryTableDDLInIsolation, qualifyIndexName, quote, registerColumnType, registerColumnType, registerFunction, registerHibernateType, registerHibernateType, registerKeyword, registerResultSetOutParameter, remapSqlTypeDescriptor, replaceResultVariableInOrderByClauseWithPosition, requiresCastingOfParametersInSelectClause, supportsBindAsCallableArgument, supportsCascadeDelete, supportsCaseInsensitiveLike, supportsCircularCascadeDeleteConstraints, supportsColumnCheck, supportsEmptyInList, supportsExistsInSelect, supportsExpectedLobUsagePattern, supportsIdentityColumns, supportsIfExistsAfterTableName, supportsIfExistsBeforeTableName, supportsInsertSelectIdentity, supportsLimitOffset, supportsLobValueChangePropogation, supportsLockTimeouts, supportsNotNullUnique, supportsOuterJoinForUpdate, supportsParametersInInsertSelect, supportsPooledSequences, supportsResultSetPositionQueryMethodsOnForwardOnlyCursor, supportsRowValueConstructorSyntax, supportsRowValueConstructorSyntaxInInList, supportsSubqueryOnMutatingTable, supportsSubselectAsInPredicateLHS, supportsTableCheck, supportsTupleCounts, supportsTupleDistinctCounts, supportsUnboundedLobLocatorMaterialization, supportsUnique, supportsUniqueConstraintInCreateAlterTable, supportsVariableLimit, toBooleanValueString, toString, transformSelectString, useInputStreamToInsertBlob`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CUBRIDDialect

    public CUBRIDDialect()

Method Detail

### getIdentityColumnString

    protected String getIdentityColumnString()
                                      throws MappingException

  Description copied from class: `Dialect`
  The syntax used during DDL to define a column as being an IDENTITY.

  Overrides:
    `getIdentityColumnString` in class `Dialect`
  Returns:
    The appropriate DDL fragment.
  Throws:
    `MappingException` - If IDENTITY generation is not supported.

### getIdentitySelectString

    public String getIdentitySelectString(String table,
                                          String column,
                                          int type)
                                   throws MappingException

  Description copied from class: `Dialect`
  Get the select command to use to retrieve the last generated IDENTITY value for a particular table

  Overrides:
    `getIdentitySelectString` in class `Dialect`
  Parameters:
    `table` - The table into which the insert was done
    `column` - The PK column.
    `type` - The `Types` type code.
  Returns:
    The appropriate select command
  Throws:
    `MappingException` - If IDENTITY generation is not supported.

### getAddColumnString

    public String getAddColumnString()

  Description copied from class: `Dialect`
  The syntax used to add a column to a table (optional).

  Overrides:
    `getAddColumnString` in class `Dialect`
  Returns:
    The "add column" fragment.

### getSequenceNextValString

    public String getSequenceNextValString(String sequenceName)

  Description copied from class: `Dialect`
  Generate the appropriate select statement to to retrieve the next value of a sequence.

  This should be a "stand alone" select statement.

  Overrides:
    `getSequenceNextValString` in class `Dialect`
  Parameters:
    `sequenceName` - the name of the sequence
  Returns:
    String The "nextval" select string.

### getCreateSequenceString

    public String getCreateSequenceString(String sequenceName)

  Description copied from class: `Dialect`
  Typically dialects which support sequences can create a sequence with a single command. This is convenience form of `Dialect.getCreateSequenceStrings(java.lang.String)` to help facilitate that.

  Dialects which support sequences and can create a sequence in a single command need *only* override this method. Dialects which support sequences but require multiple commands to create a sequence should instead override `Dialect.getCreateSequenceStrings(java.lang.String)`.

  Overrides:
    `getCreateSequenceString` in class `Dialect`
  Parameters:
    `sequenceName` - The name of the sequence
  Returns:
    The sequence creation command

### getDropSequenceString

    public String getDropSequenceString(String sequenceName)

  Description copied from class: `Dialect`
  Typically dialects which support sequences can drop a sequence with a single command. This is convenience form of `Dialect.getDropSequenceStrings(java.lang.String)` to help facilitate that.

  Dialects which support sequences and can drop a sequence in a single command need *only* override this method. Dialects which support sequences but require multiple commands to drop a sequence should instead override `Dialect.getDropSequenceStrings(java.lang.String)`.

  Overrides:
    `getDropSequenceString` in class `Dialect`
  Parameters:
    `sequenceName` - The name of the sequence
  Returns:
    The sequence drop commands

### supportsSequences

    public boolean supportsSequences()

  Description copied from class: `Dialect`
  Does this dialect support sequences?

  Overrides:
    `supportsSequences` in class `Dialect`
  Returns:
    True if sequences supported; false otherwise.

### getQuerySequencesString

    public String getQuerySequencesString()

  Description copied from class: `Dialect`
  Get the select command used retrieve the names of all sequences.

  Overrides:
    `getQuerySequencesString` in class `Dialect`
  Returns:
    The select command; or null if sequences are not supported.
  See Also:
    `SchemaUpdate`

### dropConstraints

    public boolean dropConstraints()

  Description copied from class: `Dialect`
  Do we need to drop constraints before dropping tables in this dialect?

  Overrides:
    `dropConstraints` in class `Dialect`
  Returns:
    True if constraints must be dropped prior to dropping the table; false otherwise.

### supportsLimit

    public boolean supportsLimit()

  Description copied from class: `Dialect`
  Does this dialect support some form of limiting query results via a SQL clause?

  Overrides:
    `supportsLimit` in class `Dialect`
  Returns:
    True if this dialect supports some form of LIMIT.

### getLimitString

    public String getLimitString(String sql,
                                 boolean hasOffset)

  Description copied from class: `Dialect`
  Apply s limit clause to the query.

  Typically dialects utilize `variable` limit clauses when they support limits. Thus, when building the select command we do not actually need to know the limit or the offest since we will just be using placeholders.

  Here we do still pass along whether or not an offset was specified so that dialects not supporting offsets can generate proper exceptions. In general, dialects will override one or the other of this method and `Dialect.getLimitString(String, int, int)`.

  Overrides:
    `getLimitString` in class `Dialect`
  Parameters:
    `sql` - The query to which to apply the limit.
    `hasOffset` - Is the query requesting an offset?
  Returns:
    the modified SQL

### bindLimitParametersInReverseOrder

    public boolean bindLimitParametersInReverseOrder()

  Description copied from class: `Dialect`
  ANSI SQL defines the LIMIT clause to be in the form LIMIT offset, limit. Does this dialect require us to bind the parameters in reverse order?

  Overrides:
    `bindLimitParametersInReverseOrder` in class `Dialect`
  Returns:
    true if the correct order is limit, offset

### useMaxForLimit

    public boolean useMaxForLimit()

  Description copied from class: `Dialect`
  Does the `LIMIT` clause take a "maximum" row number instead of a total number of returned rows?

  This is easiest understood via an example. Consider you have a table with 20 rows, but you only want to retrieve rows number 11 through 20. Generally, a limit with offset would say that the offset = 11 and the limit = 10 (we only want 10 rows at a time); this is specifying the total number of returned rows. Some dialects require that we instead specify offset = 11 and limit = 20, where 20 is the "last" row we want relative to offset (i.e. total number of rows = 20 - 11 = 9)

  So essentially, is limit relative from offset? Or is limit absolute?

  Overrides:
    `useMaxForLimit` in class `Dialect`
  Returns:
    True if limit is relative from offset; false otherwise.

### forUpdateOfColumns

    public boolean forUpdateOfColumns()

  Description copied from class: `Dialect`
  Is `FOR UPDATE OF` syntax supported?

  Overrides:
    `forUpdateOfColumns` in class `Dialect`
  Returns:
    True if the database supports `FOR UPDATE OF` syntax; false otherwise.

### closeQuote

    public char closeQuote()

  Description copied from class: `Dialect`
  The character specific to this dialect used to close a quoted identifier.

  Overrides:
    `closeQuote` in class `Dialect`
  Returns:
    The dialect's specific close quote character.

### openQuote

    public char openQuote()

  Description copied from class: `Dialect`
  The character specific to this dialect used to begin a quoted identifier.

  Overrides:
    `openQuote` in class `Dialect`
  Returns:
    The dialect's specific open quote character.

### hasAlterTable

    public boolean hasAlterTable()

  Description copied from class: `Dialect`
  Does this dialect support the `ALTER TABLE` syntax?

  Overrides:
    `hasAlterTable` in class `Dialect`
  Returns:
    True if we support altering of tables; false otherwise.

### getForUpdateString

    public String getForUpdateString()

  Description copied from class: `Dialect`
  Get the string to append to SELECT statements to acquire locks for this dialect.

  Overrides:
    `getForUpdateString` in class `Dialect`
  Returns:
    The appropriate `FOR UPDATE` clause string.

### supportsUnionAll

    public boolean supportsUnionAll()

  Description copied from class: `Dialect`
  Does this dialect support UNION ALL, which is generally a faster variant of UNION?

  Overrides:
    `supportsUnionAll` in class `Dialect`
  Returns:
    True if UNION ALL is supported; false otherwise.

### supportsCommentOn

    public boolean supportsCommentOn()

  Overrides:
    `supportsCommentOn` in class `Dialect`

### supportsTemporaryTables

    public boolean supportsTemporaryTables()

  Description copied from class: `Dialect`
  Does this dialect support temporary tables?

  Overrides:
    `supportsTemporaryTables` in class `Dialect`
  Returns:
    True if temp tables are supported; false otherwise.

### supportsCurrentTimestampSelection

    public boolean supportsCurrentTimestampSelection()

  Description copied from class: `Dialect`
  Does this dialect support a way to retrieve the database's current timestamp value?

  Overrides:
    `supportsCurrentTimestampSelection` in class `Dialect`
  Returns:
    True if the current timestamp can be retrieved; false otherwise.

### getCurrentTimestampSelectString

    public String getCurrentTimestampSelectString()

  Description copied from class: `Dialect`
  Retrieve the command used to retrieve the current timestamp from the database.

  Overrides:
    `getCurrentTimestampSelectString` in class `Dialect`
  Returns:
    The command.

### isCurrentTimestampSelectStringCallable

    public boolean isCurrentTimestampSelectStringCallable()

  Description copied from class: `Dialect`
  Should the value returned by `Dialect.getCurrentTimestampSelectString()` be treated as callable. Typically this indicates that JDBC escape syntax is being used...

  Overrides:
    `isCurrentTimestampSelectStringCallable` in class `Dialect`
  Returns:
    True if the `Dialect.getCurrentTimestampSelectString()` return is callable; false otherwise.

Copyright © 2001-2012 Red Hat, Inc. All Rights Reserved.